<?php
// Check if the current URL ends with '/addons'
$currentUrl = $_SERVER['REQUEST_URI'];
if (substr($currentUrl, -7) === '/addons' || (strpos($currentUrl, 'order-steps/server/') !== false && substr($currentUrl, -14) === '/configuration')) {

    class gpAddon extends Models
    {
        // Method to retrieve addons from the database
        public function get_addons()
        {
            $stmt = $this->db->select("*")
                ->from("products_addons_lang");
            $stmt->where("name", "LIKE", "%Firewall%", '&&');
            $stmt->where("(");
            $stmt->where("name", "LIKE", "%Free%", '||');
            $stmt->where("name", "LIKE", "%20k%", '||');
            $stmt->where("name", "LIKE", "%40k%", '||');
            $stmt->where("name", "LIKE", "%80k%", '||');
            $stmt->where("name", "LIKE", "%200k%", '||');
            $stmt->where("name", "LIKE", "%500k%");
            $stmt->where(")");
            $stmt->order_by("id ASC");
            return $stmt->build() ? $stmt->fetch_assoc() : false;
        }

        public function set_addons()
        {
            $this->db->update("products_addons_lang", ['type' => "checkbox", 'properties' => ''])
                ->where("name", "LIKE", "%Firewall%", "&&")
                ->where("(")
                ->where("name", "LIKE", "%Free%", '||')
                ->where("name", "LIKE", "%20k%", '||')
                ->where("name", "LIKE", "%40k%", '||')
                ->where("name", "LIKE", "%80k%", '||')
                ->where("name", "LIKE", "%200k%", '||')
                ->where("name", "LIKE", "%500k%")
                ->where(")")
                ->save();
        }
    }

    $request = new gpAddon();

    // Set & Retrieve addons from the database
    $setAddon = $request->set_addons();
    $result = $request->get_addons();

    $script = '';
    $addons_ids = array();
   
    if (is_array($result) && count($result) > 1) {
        $product_addons = explode(",", $this->template_params['product']['addons']);

        foreach ($result as $key => $value) {
            $addons_ids[] = $value['owner_id'];
        }
        foreach ($addons_ids as $key => $id) {
            if (!in_array($id, $product_addons)) {
                unset($addons_ids[$key]);
            }
        }
        $addons_ids = array_values($addons_ids);
        $i = 0;
        // Check if there is more than one addon
        foreach ($addons_ids as $key => $value) {
            // Generate script to remove inputs
            if ($i > 0) {
                $script .= 'removeInputByNumber(' . $value . ');';
            }
            $i++;
        }
    }
    

    // Check if there is more than one addon to generate script
    if (count($addons_ids) > 1) {
?>
        <script>
            function removeInputByNumber(number) {
                var label = document.querySelector('label[for="addon-' + number + '-none"]');
                var input = document.getElementById('addon-' + number + '-0"]');
                if (label) {
                    var nextSibling = label.nextElementSibling;
                    if (nextSibling && nextSibling.tagName === 'BR') {
                        nextSibling.remove();
                    }
                    label.remove();
                    document.getElementById('addon-' + number + '-none').style.display = 'none';
                }
            }

            document.addEventListener('DOMContentLoaded', function() {
                <?php echo $script; ?>

                // Add event listener for the first addon
                <?php
                echo "document.getElementById('addon-$addons_ids[0]-none').addEventListener('change', function() {\n";
                echo "    if (document.getElementById('addon-$addons_ids[0]-none').checked = true) {\n";
                echo "        document.getElementById('addon-$addons_ids[0]-0').checked = false;\n";
                foreach ($addons_ids as $other_id) {
                    if ($other_id !== $addons_ids[0]) {
                        echo "        document.getElementById('addon-$other_id-0').checked = false;\n";
                    }
                }
                echo "    }\n";
                echo "});\n";

                // Add event listeners for the remaining addons
                foreach ($addons_ids as $addon_id) {
                    echo "document.getElementById('addon-$addon_id-0').addEventListener('change', function() {\n";
                    echo "    if (document.getElementById('addon-$addon_id-0').checked = true) {\n";
                    echo "        document.getElementById('addon-$addons_ids[0]-none').checked = false;\n";
                    foreach ($addons_ids as $other_id) {
                        if ($other_id !== $addon_id) {
                            echo "        document.getElementById('addon-$other_id-0').checked = false;\n";
                        }
                    }
                    echo "    }\n";
                    echo "});\n";
                }
                ?>
            });
        </script>
<?php
    }
}
?>